# TASK multiprep.cl
# MULTI-SLIT DATA PROCESSING
# FOR EACH OF THE SLIT POSITIONS READ FROM FILE:
#    prepare file with:
#    - flat field fit parameters
#    - zero order(s) position(s)
#    - zero order(s) fit parameters
#    - sky background fit parameters
# OLIVIER LE FEVRE
# 15 Dec 1992, v1.0
# 18 Dec 1992, v1.1

procedure multiprep(spec_ima,slit_pos,slit_num,flat_ima,Output)

string spec_ima {prompt="Image w/ 2D spectra"}
string slit_pos {prompt="File w/ slit positions"}
int slit_num {1, prompt="Slit number to start"}
string flat_ima {prompt="Flat Image"}
string Output   {prompt="Output file"}
real lambda0 {prompt="Zero deviation wavelength"}
real lambda1 {prompt="Start wavelength"}
real lambda2 {prompt="End wavelength"}
real disper {prompt="Dispersion in A/pix"}
int ordre {prompt="Order for the default flat spline3 fit ?"}
bool cb {yes, prompt="Correct for flat field ?"}
bool anext = yes {prompt="Go to next object ?", mode="q"}
bool previous = yes {prompt="Redo previous object (yes/no) ?", mode="q"}
bool stop = yes {prompt="Quit program ?", mode="q"}

struct *crtlist {mode="hl"}
struct *imgdd {mode="hl"}
struct *insertlist {mode="hl"}
struct *imdispp {mode="hl"}
struct *pixcorf {mode="hl"}

begin
	bool anszero,test1, anscor, test2
	int ii = 1
	int ij = 1
	int jj = 0
	int ijj = 0
	int xima = 1
	int xima2 = 1
	int i = 0
	int iii = 1
	int lll0 = 0
	int aaa = 0
	int bbb = 0
	int xmin, xmax, ymin, ymax, xcalmin, xcalmax, lmax, xmax2, ymax2
	int x, y, l, i2, i3, diff, ylow, yhigh,xminf,xmaxf
	int y2, ymin2, yima2, llll, lll, ll2
	int xc1[3],xc2[3],yc1[3],yc2[3],number,num,xi,yi,ymid,yavg,ysup,yrep
	int x1,x2,x3,x4,x5,x6, orderzero, os1, os2, os3, oss
	int ll[1000],os,of
	int xca1,xca2,yca1,yca2,xcb1,xcb2,ycb1,ycb2,xcc1,xcc2,ycc1,ycc2
	int xcor,ycor,xins,yins,xflat1,xflat2
	string imagein, list, imfin, imgfile, bias, imageback 
#	string zeropos1,insertpos1,zeropos2,insertpos2,zeropos3,insertpos3
	string zeropos, insertpos
	string imageflaten, imagebias, flat, imageflat, imageflatfin, refcal
	string imagecal, aa1,aa2,aa3,aa4
	string lambda, lambcal, imagecala, imfina, imfinal, ims, imindiv
	string imgff, imgg, imagerest, imfinraw, iflatsmooth
	string imagezero,imagezerocor,func, funczero, funczero1,funczero2
	string funczero3, idnum, filezerocor
	string imb, imf, img, corfile, imsens, imdisp, imfinala, imdispa
	string listflatfin, imgdisp, corfile2, pixcor
#	string imagezerocor1,imagezerocor2,imagezerocor3
	real disp_cen, ratio, xxm, yym,intcor	

	imagein=spec_ima
	list=slit_pos
	imfin=Output
	flat=flat_ima
	crtlist=list

# set temporary image names

	imf = mktemp ("ttsf")
	imageflat = mktemp ("ttf")
	imageflaten = mktemp ("ttff")

# start loop on slit positions file

	while (fscan (crtlist, x, y, l) != EOF)  {

	if ( ii < slit_num ) goto slit
toto:
#	print (ii)
	print (x,y,l)

	ims = mktemp ("tts")
	imageflatfin = mktemp ("ttfff")
	imagerest = mktemp ("ttrest")
	imagezero = mktemp ("ttzero")

	aaa = 0
	bbb = 0
	jj = 0
	ij = 1

	   x=x
	   xmin = x-l/2
	   xmax = x+l/2-1
	   xcalmin = x-2
	   xcalmax = x+2
	   lmax=l-1

# get input images pixel size in Y axis

	   imgets (imagein,"i_naxis2", value="")
	   ymax=int(imgets.value)

	   print(ymax)

	   xima=xima+1+l

# compute ymin and ymax

	  ylow=y-(lambda0-lambda1)/disper
	  yhigh=y+(lambda2-lambda0)/disper

	  if (ylow < 1 ) {
	    ymin=1
	  } else {
	    ymin=ylow
	  }

	  if ( yhigh > ymax ) {
	    ymax=ymax
	  } else {
	    ymax=yhigh
	  }

	  print("ymin,ymax")
	  print(ymin,ymax)

	if ( cb == yes ) {

	print("subraster flat")

	  imcopy(flat//"["//xmin//":"//xmax//","//ymin//":"//ymax//"]",
	   imf//ii, verbose=no)

	   imgets (imf//ii,"i_naxis2", value="")
	   ymax2=int(imgets.value)

#  fit flat image to get flat field fitting parameters

	print("response yes/yes")

        xminf = 10
        xmaxf = xmax-xmin-10

           response(imf//ii,
             imf//ii//"["//xminf//":"//xmaxf//",*]",
             imageflaten//ii, threshold=INDEF,
             interactive=yes, sample="1:"//ymax2//"",naverage=3,
             function="spline3", order=ordre,, low_reject=3.,
             high_reject=3.,
             niterate=5, grow=4., graphics="stdgraph", cursor="")

#	display(imageflaten//ii)

	print("Type fit params. for flat: x1 x2 order (spline3)")
	scan(xflat1, xflat2, of)
	print(xflat1,xflat2,of)

	print("subraster image")

	imarith(imagein//"["//xmin//":"//xmax//","//ymin//":"//ymax//"]","/",
	imageflaten//ii, imageflatfin//ii)

	} else {

	xflat1=0
	xflat2=0
	of=0

	imcopy(imagein//"["//xmin//":"//xmax//","//ymin//":"//ymax//"]",
	imageflatfin//ii)

	}

	display (imageflatfin//ii,
	 1, erase=yes, border_erase=yes, select_frame=yes, repeat=no, 
	 fill=yes, zscale=yes, contrast=0.25, zrange=no, nsample_line=5, 
	 xcenter=0.5, ycenter=0.5, xsize=1., ysize=1., xmag=1., 
	 ymag=1., order=0, z1=0., z2=3000.,
	 ztrans="linear", lutfile="")

	print("Enter number of zero order regions")
	scan(number)

	if ( number == 0 ) {

        xca1=0
        xca2=0
        yca1=0
        yca2=0
        xcb1=0
        xcb2=0
        ycb1=0
        ycb2=0
        xcc1=0
        xcc2=0
        ycc1=0
        ycc2=0
	funczero1="a"
	funczero2="a"
	funczero3="a"
	os1=0
	os2=0
	os3=0

	}

	if ( number == 1 ) {

        xcb1=0
        xcb2=0
        ycb1=0
        ycb2=0
        xcc1=0
        xcc2=0
        ycc1=0
        ycc2=0
	funczero2="a"
	funczero3="a"
	os2=0
	os3=0

	}

	if ( number == 2 ) {

        xcc1=0
        xcc2=0
        ycc1=0
        ycc2=0
	funczero3="a"
	os3=0

	}


	if ( number != 0 ) {
 
	for (i=1; i<=number; i+=1 ) {

	print("Enter zero order area: x1 x2 y1 y2")
	scan(xc1[i],xc2[i],yc1[i],yc2[i])

	print(xc1[i],xc2[i],yc1[i],yc2[i])

	imcopy(imageflatfin//ii//
	"["//xc1[i]//":"//xc2[i]//","//yc1[i]//":"//yc2[i]//"]",
	imagerest//i)

	fit1d (imagerest//i,
	imagezero//i, "difference", axis=1, interactive=yes, sample="*", 
	naverage=1,
	function="spline3", order=1, low_reject=2., high_reject=2., niterate=1,
	grow=0., graphics="stdgraph", cursor="")
 
	print("Enter fit parameters: function order")
	scan(funczero,orderzero)

	print(funczero, orderzero)

	if ( i == 1 ) { 
	  os1=orderzero
	  funczero1=funczero 
	  print(funczero1, os1) 
          xca1=xc1[i]
          xca2=xc2[i]
          yca1=yc1[i]
          yca2=yc2[i]
	}

	if ( i == 2 ) { 
	  os2=orderzero
	  funczero2=funczero 
	  print(funczero2, os2) 
          xcb1=xc1[i]
          xcb2=xc2[i]
          ycb1=yc1[i]
          ycb2=yc2[i]
	}

	if ( i == 3 ) { 
	  os3=orderzero
	  funczero3=funczero 	
	  print(funczero3, os3) 
          xcc1=xc1[i]
          xcc2=xc2[i]
          ycc1=yc1[i]
          ycc2=yc2[i]
	}


	  }
	}

	fit1d (imageflatfin//ii,
	imageflatfin//ii, "difference", axis=1, interactive=yes, sample="*", 
	naverage=1,
	function="spline3", order=1, low_reject=2., high_reject=2., niterate=1,
	grow=0., graphics="stdgraph", cursor="")
 
	print("Enter sky background fit sample: x1 x2 x3 x4 x5 x6")
	scan(x1,x2,x3,x4,x5,x6)

	print("Enter sky background fit params: function order")
	scan(func,os)

# clean-up

	imdel(imf//"*.imh")
	imdel(imagerest//"*.imh")
	imdel(imagezero//"*.imh")
	imdel(imageflaten//"*.imh")
	imdel(imageflatfin//ii)

	  if ( anext == yes ) {

# create output text file for slit

	print(x, y, l, xflat1, xflat2, of,number,
        xca1,xca2,yca1,yca2,funczero1," ",os1,
        xcb1,xcb2,ycb1,ycb2,funczero2," ",os2,
        xcc1,xcc2,ycc1,ycc2,funczero3," ",os3,
        x1,x2,x3,x4,x5,x6, func," ",os, >> imfin)

	    aaa = 1

 	  } else if ( previous == yes ) {

	    print(previous)

	    bbb = 1

	    goto toto

	  } else {

# create output text file for slit

	print(x, y, l, xflat1, xflat2, of,number,
        xca1,xca2,yca1,yca2,funczero1," ",os1,
        xcb1,xcb2,ycb1,ycb2,funczero2," ",os2,
        xcc1,xcc2,ycc1,ycc2,funczero3," ",os3,
        x1,x2,x3,x4,x5,x6, func," ",os, >> imfin)

	  }

	  print(aaa,bbb)

	  if ( aaa != 1 ) {
	    if ( bbb != 1 ) {
	      print("get out")
	      break
	    }
	  }

slit:

	ii+=1
	ij=1
#	print(ii)

	}

	end
	

