# TASK multiview.cl
# MULTI-SLIT DATA PROCESSING
# THIS PROCEDURE EXTRACTS INDIVIDUAL 2D SPECTRUM FROM AN IMAGE WITH 
# MULTIPLE 2D SPECTRA
# OLIVIER LE FEVRE 
# version 1: November 26, 1992

procedure multiview (spec_ima,slit_num,spec1d)

string spec_ima {prompt="Spectrum root name"}
int slit_num {1, prompt="Slit number"}
string spec1d {prompt="1D spectrum"}
string flux_cal {prompt="sensitivity image for flux calib"}
bool ca {yes, prompt="Do you want to extract sky corrected spectra ?"}

begin
	int ij = 1
	int xmax, ymax, zmax, ii
	string imageback, imagefin, imspec2d,imspec1d,imfina,imfinaa,imagecala,imsens
	real disp_cen, ratio

	imagefin=spec_ima
	imsens=flux_cal
	ii=slit_num
	imspec2d=imagefin//ii
	imspec1d=imagefin//ii//".0001"
	imageback=imagefin//"back"//ii
	imfina=imagefin//"sky"//ii
	imagecala=imagefin//"cal"//ii//".0001"
	imfinaa = imfina//".000*.imh"

	imgets (imageback,"i_naxis1", value="")
	xmax=int(imgets.value)

	imgets (imageback,"i_naxis2", value="")
	ymax=int(imgets.value)

	imgets (imageback,"i_naxis3", value="")
	zmax=int(imgets.value)

	print(xmax,ymax,zmax)

	ratio=xmax*1./(ymax*1.)
	disp_cen=ratio/2.

	for (ij=1; ij <= zmax; ij+=1) {

	  print(ij,disp_cen)

	  if ( disp_cen >= 1 ) {
	    disp_cen=1.-ratio/2
	  }

	if (ij == 1) {

	   display (imageback//"[*,*,"//ij//"]",
	   1, erase=yes, border_erase=no, select_frame=yes, repeat=no, 
	   fill=yes, zscale=yes, contrast=0.25, zrange=no, nsample_line=5, 
	   xcenter=disp_cen, ycenter=0.5, xsize=1., ysize=1., xmag=1., 
	   ymag=1., order=0, z1=900., z2=3000.,
	   ztrans="linear", lutfile="")

	} else {

	   display (imageback//"[*,*,"//ij//"]",
	   1, erase=no, border_erase=no, select_frame=yes, repeat=no, 
	   fill=yes, zscale=yes, contrast=0.25, zrange=no, nsample_line=5, 
	   xcenter=disp_cen, ycenter=0.5, xsize=1., ysize=1., xmag=1., 
	   ymag=1., order=0, z1=900., z2=3000.,
	   ztrans="linear", lutfile="")

	}

	  disp_cen=disp_cen+ratio

	}

	if ( disp_cen >= 1 ) {
	  disp_cen=1.-ratio/2
	 }

	display (imspec2d,
	1, erase=no, border_erase=no, select_frame=yes, repeat=no, 
	fill=yes, zscale=yes, contrast=0.25, zrange=no, nsample_line=5, 
	xcenter=disp_cen, ycenter=0.5, xsize=1., ysize=1., xmag=1., 
	ymag=1., order=0, z1=900., z2=3000.,
	ztrans="linear", lutfile="")

	if (ca == yes) {

#  extract object spectrum

	print("apsum objet")

	   apsum (imspec2d,
	   output=imfina, format="onedspec", references="", 
	   profiles="", interactive=yes,
	   find=no, recenter=no, resize=no, edit=yes, trace=yes, fittrace=yes,
	   extract=yes, extras=no, review=yes, line=INDEF, nsum=300, 
	   background="none", weights="variance", pfit="fit1d", clean=yes,
	   skybox=1, saturation=INDEF,
	   readnoise="9.", gain="6.5", lsigma=4., usigma=4., nsubaps=1)


# assign reference spectrum and wavelength calibrate object spectrum 
# do it for all 1D spectra extracted from current 2D spectrum

	print("refspec")

	   refspectra (imfinaa,
	   "yes", references=imagecala, apertures="", refaps="", ignoreaps=yes,
	   select="interp", sort="", group="", time=yes, timewrap=17., 
	   override=no,
	   confirm=yes, assign=yes, logfiles="STDOUT,logfile", verbose=no)
 
	print("dispcor")

	   dispcor (imfinaa,
	   imfinaa, linearize=yes, database="database", table="", 
	   w1=INDEF, w2=INDEF,
#	   dw=INDEF, nw=INDEF, log=no, flux=yes, samedisp=no, 
	   dw=INDEF, nw=INDEF, flux=yes, samedisp=no, 
	   global=no, ignoreaps=yes,
	   confirm=no, listonly=no, verbose=yes, logfile="")

	print("fluxcalib")

	   fluxcalib (imfinaa,
	   imfinaa, imsens, fnu=yes, exposure="inttime")

	}

# splot final

	   splot (imspec1d)	   

	end
	

